
structure NaiveBayes :> NAIVE_BAYES_CLASSIFIER =
struct

    type category = string

    type labeled_document = category * string Seq.seq
    type document = string Seq.seq
        
    type statistics = 
          (category,int) Dict.dict           (* maps each category to number of documents with that category *)
        * (category,int) Dict.dict           (* maps each category to number of words in documents with that category *)
        * (category * string, int) Dict.dict (* maps each (cat,word) to frequency *)
        * category Seq.seq                   (* list of categories (no duplicates) *)
        * int                                (* total number of documents *)
        * int                                (* total number of different words *)

    (* TASK *)
    fun gather (train : labeled_document MR.mapreducable) : statistics = raise Fail "unimplemented"
        
    (* TASK *)
    fun possible_classifications 
        ((num_docs_by_cat,
          num_words_by_cat,
          freqs,
          all_categories, 
          total_num_docs,
          total_num_words) : statistics,
         test_doc : document) : (category * real) Seq.seq = raise Fail "unimplemented"

    (* TASK *)
    fun classify (stats : statistics, test_doc : document) : (category * real) = raise Fail "unimplemented"

    (* TASK *)
    fun train_classifier (train : labeled_document MR.mapreducable) : document -> (category * real) =
        raise Fail "unimplemented"
        
end
